package dev.peerat.parser.java.tree;

import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class FunctionContainerTree extends SyntaxTree<JavaElement> {

	public FunctionContainerTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		StateTree<JavaElement> variable = this.registery.getNode(VariableTree.class);
		StateTree<JavaElement> operation = this.registery.getNode(OperationTree.class);
		
		StateTree<JavaElement> function_container = this.current;
		function_container.then((validator) -> validator.validate((token) -> token.getValue().equals(";")))
				.end((a, b) -> a);
		
		function_container.then(variable);
		function_container.then(operation);
	}

}
