package dev.peerat.parser.java.tree;

import dev.peerat.parser.TokenType;
import dev.peerat.parser.java.ClassContainer;
import dev.peerat.parser.java.Interface;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.Annotation.AnnotableBuffer;
import dev.peerat.parser.state.InitialStateTree;
import dev.peerat.parser.state.RedirectStateTree;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class InterfaceTree extends SyntaxTree<JavaElement> {

	public InterfaceTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		StateTree<JavaElement> modifier = registery.getNode(ModifierTree.class);
		StateTree<JavaElement> type = registery.getNode(TypeTree.class);
		StateTree<JavaElement> clazz_container = registery.getNode(ClassContainerTree.class);
		// INTERFACE
		StateTree<JavaElement> interfaces = this.current;
		StateTree<JavaElement> interface_base = interfaces
				.then((validator) -> validator.validate((token) -> token.getValue().equals("interface")))
				.then((validator) -> validator.validate((token) -> token.getType().equals(TokenType.NAME),
						(bag, token) -> bag.set("name", token)));
		StateTree<JavaElement> interface_start = interface_base
				.then((validator) -> validator.validate((token) -> token.getValue().equals("{")));
		interface_start.<JavaElement>end((parent, bag) -> {
			Interface current = new Interface((((AnnotableBuffer) parent).getAnnotationBuffer()), bag.get("name"),
					bag.get("extend"));
			if (parent instanceof ClassContainer)
				((ClassContainer) parent).addClass(current);
			return current;
		}).multiple(clazz_container).unique((validator) -> validator.validate((token) -> token.getValue().equals("}")))
				.end((a, b) -> a);

		interface_base.then((validator) -> validator.validate((token) -> token.getValue().equals("extends")))
				.then(new RedirectStateTree<>(type, (global, local) -> global.set("extend", local.get())))
				.then(interface_start);

//				StateTree<JavaElement> interface_mod = clazz_.then(new RedirectStateTree<>(modifier, (global, local) -> global.set("modifier", local)));
//				clazz_.then(interfaces);
//				interface_mod.then(interfaces);

		InitialStateTree<JavaElement> mult_clazz_container = new InitialStateTree<>();
		mult_clazz_container.multiple(clazz_container);
		mult_clazz_container.end((a, b) -> a);
	}

}
