package dev.peerat.parser.visitor;

import static dev.peerat.parser.java.visitor.JavaVisitor.base;
import static dev.peerat.parser.java.visitor.JavaVisitor.allClass;
import static dev.peerat.parser.java.visitor.JavaVisitor.allJavaElement;
import static dev.peerat.parser.visitor.Operator.collect;

import dev.peerat.parser.java.JavaFile;
import dev.peerat.parser.java.JavaParser;

public class Example {
	
	public static void main(String[] args) throws Exception{
		
		JavaParser parser = new JavaParser();
		JavaFile container = new JavaFile();
		parser.parse("package dev.peerat.test; public class Example{ public void helloTest(){ System.out.println(\"hello\"); } }", container);
		
		
		VisitorBag result = container.visit(
				allClass()
					.isPublic()
					.elements(
							collect(allJavaElement())
					)
				);
		
		System.out.println("result: "+result.toList());
		
		result = container.visit(base(collect(
				allClass()
					.isPublic()
					.elements(
							allJavaElement()
					)
				)));
		
		System.out.println("result: "+result.toList());
		
	}

}
