package dev.peerat.parser.visitor;

import java.util.function.Predicate;

public class Operator{
	
	//Success ? Fail ?
	public static <E,T extends Visitor<E>> T and(T... visitors){
		return (T) new Visitor<E>(){
			@Override
			public VisitorBag visit(E element){
				VisitorBag bag = new VisitorBag();
				for(T visitor : visitors){
					VisitorBag vbag = visitor.visit(element);
					bag.merge(vbag);
					if(!vbag.isValidated()) return new VisitorBag();
				}
				return bag;
			}

			@Override
			public boolean canVisit(Class<?> type){
				return true;
			}
		};
	}
	
	//Quid de si c'est empty ?
	public static <E, T extends Visitor<E>> T or(T... visitors){
		return (T) new Visitor<E>(){
			@Override
			public VisitorBag visit(E element){
				VisitorBag bag = new VisitorBag();
				for(T visitor : visitors){
					VisitorBag vbag = visitor.visit(element);
					bag.merge(vbag);
				}
				return bag;
			}

			@Override
			public boolean canVisit(Class<?> type) {
				return true;
			}
		};
	}
	
	public static <T extends Visitor<?>> T key(Visitor<?> visitor){
		return null;
	}
	
	public static <T extends Visitor<?>> T value(Visitor<?> visitor){
		return null;
	}
	
	public static <E> Visitor<E> collect(Visitor<E> visitor){
		return new Visitor<E>(){
			@Override
			public VisitorBag visit(E element){
				return visitor.visit(element).collect();
			}

			@Override
			public boolean canVisit(Class<?> type){
//				System.out.println("collect can visit ? "+type);
				return visitor.canVisit(type);
			}
		};
	}
	
	public static <E, T extends Visitor<E>> T count(T visitor, Predicate<Integer> validator){
		return (T) new Visitor<E>(){
			@Override
			public VisitorBag visit(E element){
				VisitorBag visited = visitor.visit(element);
				return validator.test(visited.toList().size()) ? visited : new VisitorBag();
			}

			@Override
			public boolean canVisit(Class<?> type) {
				return true;
			}
		};
	}

}
